// USB-HOSTCDCsTv
// PIC24FJ64GB002 MPLAB(R) XC16 C Compiler Version 1.30
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <stdint.h>
#include <PPS.h>              // Pin Re-Mapping peripheral library

// __delay_ms/__delay_usׂ̈ɕKv
#ifndef FCY
  // Unless already defined assume 16MIPS Fcyi32MHz Foscj system frequency
  #define FCY 16000000UL      // Fosc/2(16MIPS)
  #include <libpic30.h>
#endif

#include "skUARTlib.h"
#include "usb.h"
#include "app_host_cdc_basic.h"

// RtBM[V̐ݒ
// CONFIG4
#pragma config DSWDTPS  = DSWDTPS0 // fB[vEHb`hbO^C}L̃|XgXP[(1:2 2.1ms)
#pragma config DSWDTOSC = LPRC     // fB[vEHb`hbO^C}̊NbŃAd͓RCU(31KHz)
#pragma config RTCOSC   = SOSC     // RTCC̊NbŃAZJ_IV[^
#pragma config DSBOREN  = OFF      // fB[vX[vɓdd2.0VĂZbgȂ
#pragma config DSWDTEN  = OFF      // fB[vEIb`hbO^C}͖

// CONFIG3
#pragma config WPFP    = WPFP0     // ݕیtbVy[WZOgE̓y[W0(0x0)
#pragma config SOSCSEL = IO        // ZJ_IV[^̃śARA4/RB4̃fW^sƂ
#pragma config WUTSEL  = LEG       // dM[^̃EFCNAbvɕKvȎԂ̓ftHg(190us)
#pragma config WPDIS   = WPDIS     // ZOgR[hݕی͖
#pragma config WPCFG   = WPCFGDIS  // ݕیݒy[W(Ō̃y[WFlashݒ胏[h̓R[hŕی삳Ă܂)
#pragma config WPEND   = WPENDMEM  // ی삳ꂽR[hZOg̏̓vO̍Ō̃y[WŁAEWPFP

// CONFIG2
#pragma config POSCMOD  = NONE     // OIV[^̓샂[h̑I (OIV[^͎gȂ)
#pragma config I2C1SEL  = PRI      // I2C1ŎgpśASDA1(RB9)/SCL1(RB8)gp
#pragma config IOL1WAY  = OFF      // Ӌ@̃st͉xłύXolɋ
#pragma config OSCIOFNC = ON       // OSCOs@\̑I (OSCOs̓fW^I/O=RA3Ƃ)
#pragma config FCKSM    = CSDCMD   // NbN̊ĎNbNؑւ͂Ȃ
#pragma config FNOSC    = FRCPLL   // IV[^PLL삳
#pragma config PLL96MHZ = ON       // 96MHz PLL͋NɎIɗLɂȂ܂
#pragma config PLLDIV   = DIV2     // USB 96MHz PLLvXP[́AU͂2Ŋl(8MHz)
#pragma config IESO     = OFF      // FosĉQiK؂ւł̋N͂Ȃ

// CONFIG1
#pragma config WDTPS  = PS1        // EHb`hbO^C}L̃|XgXP[(1:1)
#pragma config FWPSA  = PR32       // EHb`hbO^C}L̃vXP[(1:32)
#pragma config WINDIS = OFF        // EIb`hbOɃEChE͎gȂ
#pragma config FWDTEN = OFF        // EIb`hbO̗L/"RCON.SWDTEN"rbgōs
#pragma config ICS    = PGx1       // In-Circuit Debuggers̒ʐM`ĺiPGEC1PGED1ŒʐM܂)
#pragma config GWRP   = OFF        // vOԂ݂̏͋
#pragma config GCP    = OFF        // vOԂ̃R[hEveNg͖
#pragma config JTAGEN = OFF        // JTAG ͎gpȂ

#define ENUMERATION_LED  _LATA4    // Gj[VԂLED̐ڑs

/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
int main(void)
{
     ///////////////////////////////////////////////////////////////////////////
     // MCȔlݒs                                             //
     ///////////////////////////////////////////////////////////////////////////
     _SWDTEN = 0 ;                  // EIb`hbO͖
     // VXeNbN̐ݒ(Fosc=32MHz FCY=16MIPS)
     _RCDIV = 0b000 ;               // FRC|XgXP[8MHz
     _CPDIV = 0b00 ;                // 96MHz PLLgFosc=32MHzƂ

     // I/O̐ݒ
     AD1PCFG = 0b1110111000111111 ; // AN0-AN5,AN9-AN11̓fW^I/OɊ
     TRISA   = 0b0000000000000000 ; // RA0-RA4͑Sďo͂ɐݒA1œ 0ŏo
     TRISB   = 0b0000000100000000 ; // RB8(RX1)͓́ARB0-RB5,RB7,RB9-RB11,RB13-RB15͑Sďo͂ɐݒ
     PORTA   = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     PORTB   = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     // S̊荞݂̋ݒ
     _IPL    = 0 ;                  // CPŮݗD惌xݒ(D惌xOȏ)

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̃sts                                      //
     ///////////////////////////////////////////////////////////////////////////
     // UART1@\t
     PPSUnLock ;
     iPPSInput(IN_FN_PPS_U1RX,IN_PIN_PPS_RP8) ;    // RB8(RX1)
     iPPSOutput(OUT_PIN_PPS_RP9,OUT_FN_PPS_U1TX) ; // RB9(TX1)
     PPSLock ;

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̏ݒs                                          //
     ///////////////////////////////////////////////////////////////////////////
     // UART1̏s(WbitnoParity1StopnoFlow 19200bps)
     InitUART(0, 0, 19200) ;
     
     ///////////////////////////////////////////////////////////////////////////
     // USBzXg̏ݒs                                          //
     ///////////////////////////////////////////////////////////////////////////
    // USBzXg̃X^bN
    USBHostInit(0) ;
    // CDC
    APP_HostCDCBasicInitialize() ;
    
    ENUMERATION_LED = 1 ;     // Gj[VԂLED_
    __delay_ms(3000) ;        // LED3bԒ_ׂɓĒu(NmF)
    ENUMERATION_LED = 0 ;     // Gj[VԂLED

     ///////////////////////////////////////////////////////////////////////////
     // C̃[v                                                    //
     ///////////////////////////////////////////////////////////////////////////
     while(1) {
        // foCX̃A^b`/f^b`ƃGj[VXe[g}V
        USBHostTasks() ;
        // AvP[VŗL(CDC)̃^XN
        APP_HostCDCBasicTasks() ;
     }
}
/****************************************************************************
  ֐:
    bool USB_ApplicationEventHandler( uint8_t address, USB_EVENT event,
                void *data, uint32_t size )

  Tv:
    ̓AvP[VCxgnhłB

  :
    X^bNɁANCAghCoł͂ȂAvP[Vw
    KvCxg鎞ɌĂяo܂B
    AvP[VCxgłꍇTRUEԂ܂B
    ȊȌꍇFALSEԂ܂B

  Precondition:
    None

  :
    uint8_t   address - CxgfoCX̃AhX
    USB_EVENT event   - Cxgʂ܂
    void      *data   - CxgŗL̃f[^ւ̃|C^
    uint32_t  size    - CxgŗLf[^̃TCY

  ߂l:
    TRUE    - Cxg͏܂
    FALSE   - Cxg͏܂ł

  l:
    Cxg̏Kvȏꍇ́AAvP[V̓Cxg[`ł܂B
    ׂ̈ɂ́Å֐̃Cxgʂƈv郋[`A
    ̊֐̖OƂUSB_HOST_APP_EVENT_HANDLER}N`Kv܂B
  ***************************************************************************/
bool USB_ApplicationEventHandler( uint8_t address, USB_EVENT event, void *data, uint32_t size )
{
    switch( (int)event )
    {
        /* WUSBzXgCxg ******************************************/
        case EVENT_ATTACH:             // foCXڑA^b`܂B
             ENUMERATION_LED = 1 ;     // Gj[VԂLED_
             return true;             
             break;
        case EVENT_VBUS_REQUEST_POWER: // Gj[VoCXd͂vĂ܂B
             // foCXڑꂽɂ̃Cxg邩ƎvǂႤlA
             // PICdSTATE_DETACHEDł삷
        case EVENT_HUB_ATTACH:         // USBnuڑꂽB nũT|[g͌ݗpł܂B
             return true;             
             break;
        case EVENT_VBUS_RELEASE_POWER: // USBW[̓ItVbg_E܂B
        case EVENT_UNSUPPORTED_DEVICE: // ڑĂfoCX̓AvP[VŃT|[gĂ܂B
        case EVENT_CANNOT_ENUMERATE:   // ڑĂfoCXGj[Vł܂B
        case EVENT_CLIENT_INIT_ERROR:  // NCAghCo͐ڑĂfoCXł܂B
        case EVENT_OUT_OF_MEMORY:      // zXgX^bNɁAfoCXGj[Vׂ̏\ȃq[vXy[X܂B
        case EVENT_UNSPECIFIED_ERROR:  // sȃzXgG[łB(̃G[͔܂)
             ENUMERATION_LED = 0 ;     // Gj[VԂLED
             return true;
             break;

        /* CDCNXL̃Cxg ******************************************/
        case EVENT_CDC_ATTACH:
        case EVENT_CDC_NONE:            // CxgĂȂiNULLCxgj
        case EVENT_CDC_COMM_READ_DONE:  // CDCʐM̓ǂݎ]܂
        case EVENT_CDC_COMM_WRITE_DONE: // CDCʐM̏ݓ]܂
        case EVENT_CDC_DATA_READ_DONE:  // CDCf[^ǂݎ]܂
        case EVENT_CDC_DATA_WRITE_DONE: // CDCf[^ݓ]܂
        case EVENT_CDC_RESET:           // CDCZbg
        case EVENT_CDC_NAK_TIMEOUT:     // CDCfoCXNAK^CAEg܂
                    // USBzXgCDCfpUSBCxgĂяoB
             return APP_HostCDCBasicEventHandler( address, event, data, size );
             break;

        default:
             break;
    }

    return false;

}
