/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/
/*  ̃\[X́AUSB(CDC)őMsׂ̃AvTvvOłB
 *  usb_host_cdc_interface.c usb_host_cdc.cɓ`܂B

    2019-02-05 ޒH[(ނ) Rg̓{ꉻ(Japanese commentary)
                                   foCXɃf[^𑗂鏈ǉ(Add processing to send data to device)
 */

#include "usb.h"
#include "usb_host_cdc.h"
#include "usb_host_cdc_interface.h"
#include <string.h>
#include <stdio.h>
#include "skUARTlib.h"

// *****************************************************************************
// *****************************************************************************
// Internal Function Prototypes
// *****************************************************************************
// *****************************************************************************

// *****************************************************************************
// *****************************************************************************
// Macros
// *****************************************************************************
// *****************************************************************************
#define MAX_NO_OF_IN_BYTES  64     // 1̃gUNVŎMłől(ύXs)
#define MAX_NO_OF_OUT_BYTES 64     // 1̃gUNVőMłől(ύXs)
#define CDC_ATTACHED_LED    _LATB4 // CDC̃A^b`ԂLED̐ڑs

// *****************************************************************************
// *****************************************************************************
// Type definitions
// *****************************************************************************
// *****************************************************************************
typedef enum _APP_STATE
{
    DEVICE_NOT_CONNECTED,
    GET_IN_DATA,
    GET_IN_DATA_WAIT,
    CHECK_OUT_DATA,
    SEND_OUT_DATA,
    SEND_OUT_DAT_WAITA,
    ERROR_REPORTED      /* f[^C^tF[XɃAvP[VԂǉKv */
} APP_STATE;

// *****************************************************************************
// *****************************************************************************
// Local Variables
// *****************************************************************************
// *****************************************************************************
volatile APP_STATE  CDC_State;

uint8_t inBuffer[MAX_NO_OF_IN_BYTES];   // CDCMobt@
uint8_t outBuffer[MAX_NO_OF_OUT_BYTES]; // CDCMobt@


/*******************************************************************************
*  USB֘Å荞݃nh                                                   *
*******************************************************************************/
void __attribute__((interrupt,auto_psv)) _USB1Interrupt()
{
        // USB荞݂̊荞ݏ[`
        USB_HostInterruptHandler();
}
/*********************************************************************
* Function: void APP_HostCDCBasicInitialize(void);
*
* Tv: CDC܂
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostCDCBasicInitialize()
{
    CDC_State = DEVICE_NOT_CONNECTED;
}

/*********************************************************************
* Function: void APP_HostCDCBasicTasks(void);
*
* Tv: CDCfs܂B
*
* O: fAPP_HostCDCBasicInitialize()ŏĂ͂łB
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostCDCBasicTasks()
{
    uint8_t  errorDriver, i ;
    uint8_t  numOfBytesRcvd ;
    static  uint16_t rcvnum ;

    numOfBytesRcvd = 0;

    // CDCfoCXڑĂĎgp\ǂ𒲂ׂ܂B
    // foCXG[ȂŃGj[VĂꍇtrue
    if(!USBHostCDC_ApiDeviceDetect())
    {
        CDC_ATTACHED_LED = 0 ;     // CDC̃A^b`ԂLED
        CDC_State = DEVICE_NOT_CONNECTED;
    }

    switch(CDC_State)
    {
        case DEVICE_NOT_CONNECTED:
            if(USBHostCDC_ApiDeviceDetect())
            {
                // foCXG[ȂŃGj[VĂȂ玟ɐi
                CDC_State = GET_IN_DATA;
                CDC_ATTACHED_LED = 1 ;  // CDC̃A^b`ԂLED_
            }
            break;

        case GET_IN_DATA:
            // foCXf[^Mׂ̗v
            // foCX"IN"g[NpPbg𔭍s܂B
            // IN"g[NpPbg͒IɔsȂ΂Ȃ܂A
            if(USBHostCDC_Api_Get_IN_Data(MAX_NO_OF_IN_BYTES, inBuffer))
            {
                // f[^v͐킾̂Ŏɐi
                CDC_State = GET_IN_DATA_WAIT;
            }
            break;

        case GET_IN_DATA_WAIT:
            // ](M)̊Ԃ𒲂ׂ
            // foCXɑMf[^LΑĂANAK𑗂Ă܂ő҂
            if(USBHostCDC_ApiTransferIsComplete(&errorDriver, &numOfBytesRcvd))
            {   /* G[`FbN */
                if( (errorDriver == USB_SUCCESS) && (numOfBytesRcvd != 0) )
                {
                      // f[^MAVAʐMłobɑ
                      UART_Send((char*)inBuffer, numOfBytesRcvd) ;
                      CDC_State = GET_IN_DATA;
                } else {
                      // NAKMAfoCX֑f[^L邩ׂXe[gɐi    
                      CDC_State = CHECK_OUT_DATA ;
                }
            }
            break;
            
        case CHECK_OUT_DATA:
            // VAʐMŃf[^͂Ăׂ̂
            rcvnum = UART_Available() ;
            if (rcvnum != 0) {
                if (rcvnum > MAX_NO_OF_OUT_BYTES) rcvnum = MAX_NO_OF_OUT_BYTES ;
                for (i=0 ; i<rcvnum ;i++) {
                     outBuffer[i] = (uint8_t)UART_Read() ;
                }
                // foCX֓͂Ăf[^𑗐MXe[gɐi
                CDC_State = SEND_OUT_DATA ;
            } else CDC_State = GET_IN_DATA ;
            break;

        case SEND_OUT_DATA:
                // foCX֓͂Ăf[^𑗐M
                if (USBHostCDC_Api_Send_OUT_Data(rcvnum, outBuffer)) {
                     // f[^̑Mv͐킾̂Ŏɐi
                     CDC_State = SEND_OUT_DAT_WAITA ;
                }
            break;
            
        case SEND_OUT_DAT_WAITA:
            // ](M)̊Ԃ𒲂ׂ
            // foCXԓL܂ő҂
            if(USBHostCDC_ApiTransferIsComplete(&errorDriver, &numOfBytesRcvd)) {
                /* G[`FbN */
                if( (errorDriver == USB_SUCCESS) && (numOfBytesRcvd != 0) ) {
                      // ɑMAVAʐMłobɑ
                      UART_Write('>') ;
                }
                CDC_State = GET_IN_DATA;
            }
            break;

        default:
            break;
    }
}


/*********************************************************************
* Function: bool APP_HostCDCBasicEventHandler( uint8_t address, USB_EVENT event, void *data, uint32_t size );
*
* Tv: USBzXgCDCfpUSBCxg܂B
*
* PreCondition: None
*
* Input: uint8_t   address - CxgNfoCX̃AhX
*        USB_EVENT event   - Cxg
*        void*     *data   - CxgɊ֘Af[^
*        uint32_t  size    - Cxg̃f[^TCY
*
* Output: None
*
********************************************************************/
bool APP_HostCDCBasicEventHandler( uint8_t address, USB_EVENT event, void *data, uint32_t size )
{
    switch((int)event)
    {
        case EVENT_CDC_ATTACH: 
//            SYSTEM_Initialize(SYSTEM_STATE_USB_HOST_CDC_BASIC);
            return true;
            
        case EVENT_CDC_NONE:            // CxgĂȂiNULLCxgj
        case EVENT_CDC_COMM_READ_DONE:  // CDCʐM̓ǂݎ]܂
        case EVENT_CDC_COMM_WRITE_DONE: // CDCʐM̏ݓ]܂
        case EVENT_CDC_DATA_READ_DONE:  // CDCf[^ǂݎ]܂
        case EVENT_CDC_DATA_WRITE_DONE: // CDCf[^ݓ]܂
        case EVENT_CDC_RESET:           // CDCZbg
        case EVENT_CDC_NAK_TIMEOUT:     // CDCfoCXNAK^CAEg܂
            return true;
            break;
    }

    return false;
}


