/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/

// Created by the Microchip USBConfig Utility, Version 1.0.4.0, 4/25/2008, 17:05:22

#include "usb.h"
#include "usb_host_cdc.h"

// *****************************************************************************
// Client Driver Function Pointer Table for the USB Embedded Host foundation
// *****************************************************************************

CLIENT_DRIVER_TABLE usbClientDrvTable[] =
{                                        
    {
        USBHostCDCInitialize,
        USBHostCDCEventHandler,
        0
    }
    ,
    {
        USBHostCDCInitialize,
        USBHostCDCEventHandler,
        0
    }
};

// *****************************************************************************
// USB Embedded Host Targeted Peripheral List (TPL:Targeted Peripheral List)
// *****************************************************************************

USB_TPL usbTPL[] =
{
//    VID & PID or                              Client     
//    Class, Subclass & Protcol         config  Driver  Flags  
    // C^tF[X(EP01):CDCNX,Abstract Control Mode,Common AT Commands(V25TER))
    { INIT_CL_SC_P( 2ul, 2ul, 1ul ),       0,     0,    {TPL_CLASS_DRV} }, // Communication Interface
    // C^tF[X(EP02):f[^C^[tFCX,TuNX,vgR[
    { INIT_CL_SC_P( 0x0Aul, 0ul, 0ul ),    0,     0,    {TPL_CLASS_DRV} }, // Data Interface
    //              x_ID  v_NgID:CDC RS-232 Emulation Demo
//    { INIT_VID_PID( 0x04D8ul, 0x000Aul ),  0,     0,    {0} }              // Microchip CDC-RS232 Demo
};

