/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/

// Created by the Microchip USBConfig Utility, Version 1.0.4.0, 4/25/2008, 17:05:22
/*  ̃\[X́AUSB̍\ݒ肷wb_t@CłB

    2019-02-05  ޒH[(ނ)  Rg̓{ꉻ(Japanese commentary)
 */

#ifndef _usb_config_h_
#define _usb_config_h_

// #define DEBUG_ENABLE     // "usb_host.c"t@C̃fobO\Lɂ܂B
#if defined (DEBUG_ENABLE)
    #include "../skDEBUG.h"
#endif


#define _USB_CONFIG_VERSION_MAJOR 1
#define _USB_CONFIG_VERSION_MINOR 0
#define _USB_CONFIG_VERSION_DOT   4
#define _USB_CONFIG_VERSION_BUILD 0

// Supported USB Configurations

#define USB_SUPPORT_HOST

// Hardware Configuration

#define USB_PING_PONG_MODE  USB_PING_PONG__FULL_PING_PONG

// Host Configuration

#define NUM_TPL_ENTRIES 2
#define USB_NUM_CONTROL_NAKS 20
#define USB_SUPPORT_BULK_TRANSFERS
#define USB_NUM_BULK_NAKS 10

#define USB_INITIAL_VBUS_CURRENT (100/2)     // Gj[V̋d(100ms)
#define USB_INSERT_TIME (250+1)
#define USB_HOST_APP_EVENT_HANDLER USB_ApplicationEventHandler

// zXgCDCNCAghCo̐ݒ(ʐM)

#define USB_MAX_CDC_DEVICES        1
#define USB_CDC_BAUDRATE_SUPPORTED 19200L    // 19200BPS
#define USB_CDC_PARITY_TYPE        0         // 0:None 1:Odd 2:Even
#define USB_CDC_STOP_BITS          0         // 1 Stop Bit
#define USB_CDC_NO_OF_DATA_BITS    8         // 8 Data Bit
#define USB_ENABLE_TRANSFER_EVENT

// Helpful Macros

#define USBTasks()                  \
    {                               \
        USBHostTasks();             \
        USBHostCDCTasks();          \
    }

#define USBInitialize(x)            \
    {                               \
        USBHostInit(x);             \
    }


#endif

